# remirepo/Fedora spec file for php-zendframework-zend-mvc-i18n
#
# Copyright (c) 2016-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    90e64d1304385cfcf19447b6449514e8a720adfc
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-mvc-i18n
%global php_home     %{_datadir}/php
%global library      I18n
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.1.0
Release:        1%{?dist}
Summary:        Zend Framework Mvc-%{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-intl
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.27 || ^6.5.8 || ^7.1.5",
#        "zendframework/zend-cache": "^2.6.1",
#        "zendframework/zend-coding-standard": "~1.0.0"
BuildRequires: (php-composer(container-interop/container-interop) >= 1.1    with php-composer(container-interop/container-interop) < 2)
BuildRequires: (php-autoloader(%{gh_owner}/zend-i18n)             >= 2.7    with php-autoloader(%{gh_owner}/zend-i18n)             < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-router)           >= 3.0    with php-autoloader(%{gh_owner}/zend-router)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.10 with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7.6  with php-autoloader(%{gh_owner}/zend-stdlib)           < 4)
BuildRequires: (php-autoloader(%{gh_owner}/zend-validator)        >= 2.6    with php-autoloader(%{gh_owner}/zend-validator)        < 3)
BuildRequires: (php-autoloader(%{gh_owner}/zend-cache)            >= 2.6.1  with php-autoloader(%{gh_owner}/zend-cache)            < 3)
%global phpunit %{_bindir}/phpunit7
BuildRequires:  phpunit7 >= 7.1.4
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "container-interop/container-interop": "^1.1",
#        "zendframework/zend-i18n": "^2.7",
#        "zendframework/zend-router": "^3.0",
#        "zendframework/zend-servicemanager": "^2.7.10 || ^3.0.3",
#        "zendframework/zend-stdlib": "^2.7.6 || ^3.0",
#        "zendframework/zend-validator": "^2.6"
Requires:       php(language) >= 5.6
Requires:       php(language) >= 5.6
Requires:      (php-composer(container-interop/container-interop) >= 1.1    with php-composer(container-interop/container-interop) < 2)
Requires:      (php-autoloader(%{gh_owner}/zend-i18n)             >= 2.7    with php-autoloader(%{gh_owner}/zend-i18n)             < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-router)           >= 3.0    with php-autoloader(%{gh_owner}/zend-router)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-servicemanager)   >= 2.7.10 with php-autoloader(%{gh_owner}/zend-servicemanager)   < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)           >= 2.7.6  with php-autoloader(%{gh_owner}/zend-stdlib)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-validator)        >= 2.6    with php-autoloader(%{gh_owner}/zend-validator)        < 3)
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.0.0
Requires:       php-intl
Requires:       php-spl
%if ! %{bootstrap}
# From composer, "suggest": {
#        "zendframework/zend-cache": "To enable caching of translation strings"
Suggests:       php-autoloader(%{gh_owner}/zend-cache)
%endif

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
zend-mvc-i18n provides integration between:

* zend-i18n
* zend-mvc
* zend-router

and replaces the i18n functionality found in the v2 releases of the latter
two components.

* File issues at https://github.com/zendframework/zend-mvc-i18n/issues
* Documentation is at https://zendframework.github.io/zend-mvc-i18n/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
require_once '%{php_home}/Interop/Container/autoload.php';
EOF


: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Interop/Container/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/Router/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
    '%{php_home}/Zend/Validator/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Cache/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/Mvc
cp -pr src %{buildroot}%{php_home}/Zend/Mvc/%{library}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/Mvc-%{library}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/Mvc/%{library}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\Mvc\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php70 %{_bindir}/phpunit6" php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit7} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/Mvc/%{library}
%{php_home}/Zend/Mvc-%{library}-autoload.php


%changelog
* Thu May  3 2018 Remi Collet <remi@remirepo.net> - 1.1.0-1
- update to 1.1.0
- use range dependencies
- switch to phpunit7
- raise dependency on zend-servicemanager 2.7.10

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 1.1.10-4
- switch from zend-loader to fedora/autoloader

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.0.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Wed Jun 29 2016 Remi Collet <remi@fedoraproject.org> - 1.1.10-1
- initial package

